/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package mdbwhileloop;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;

/**
 *
 * @author bhavani
 */
@MessageDriven(mappedName = "jms/MDBWhileLoopQueue", activationConfig = {
@ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge"),
@ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue")
})
public class MessageReceiverBean implements MessageListener {

    public MessageReceiverBean() {
    }

    public void onMessage(Message message) {
        try {
            String msg = ((TextMessage) message).getText();
            System.out.println("mdbwhileloop.MessageReceiverBean :: " +
                    "received message <" + msg + ">");
            startWhileLoop(msg, 10);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void startWhileLoop(String msg, int count) {
        while (count >= 0) {
            try {
                System.out.println("mbdwhileloop.MessageReceiverBean :: " +
                        "inside while loop, sleeping for 10 seconds, " +
                        "msg = " + msg + ", count = " + count);
                Thread.sleep(10 * 1000);
                --count;
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        }
        System.out.println("mbdwhileloop.MessageReceiverBean :: " +
                "while loop ended");
    }
}
